-- Lesson: 	Seasonal temperature variation 
--			.
-- Author:	Tiago Carneiro

-----------------------------------------------------------------
-- PARAMETER
-----------------------------------------------------------------

-----------------------------------------------------------------
-- MODEL
-----------------------------------------------------------------

function simulateSeasonalTemperature(t, amplitude, periodicity, translationY, translationX)
	return (amplitude/2) * math.sin(2*math.pi*(1/periodicity)*t + translationX) + translationY 
end

ag = Agent{
	stock  		= 0,
	execute		= function( self, t, amplitude, periodicity, translationY, translationX )
		self.stock = simulateSeasonalTemperature(t, amplitude, periodicity, translationY, translationX)
	end
}

--------------------------------------------------------------
-- SIMULATION
--------------------------------------------------------------

print( simulateSeasonalTemperature( 0, 				2, 1, 0, 0 ) )      				-- 0
print( simulateSeasonalTemperature( 1/4, 			2, 1, 0, 0 ) ) 					-- 1
print( simulateSeasonalTemperature( 1/12, 			2, 1, 0, 0 ) ) 	 				-- 0.5
print( simulateSeasonalTemperature( 0, 				4, 1, 0, 0 ) )      				-- 0
print( simulateSeasonalTemperature( 1/4, 			4, 1, 0, 0 ) ) 					-- 2
print( simulateSeasonalTemperature( 1/12, 			4, 1, 0, 0 ) )  					-- 1
print( simulateSeasonalTemperature( 0, 				2, 2, 0, 0 ) )      				-- 0
print( simulateSeasonalTemperature( 1/2, 			2, 2, 0, 0 ) ) 					-- 1
print( simulateSeasonalTemperature( 1/6, 			2, 2, 0, 0 ) )  					-- 0.5
print( simulateSeasonalTemperature( 365/4, 		8, 365, 32, 0) )				-- 36
print( simulateSeasonalTemperature( 365*1.75, 	8, 365, 32, 0) )				-- 28
print( simulateSeasonalTemperature( 0, 				8, 365, 32, math.pi/2) )	-- 36

obs1 = Observer{subject = ag, type = "chart", attributes = {"stock"} }


for t = 1, 365 do -- try 730

	ag:execute( t, 8, 365, 32, math.pi/2);
	
	ag:notify(t)
	
end