-- Lesson: Room & oven losing heat - Alternative 1.
-- Author: Tiago Carneiro

--------------------------------------------------------------
-- PARAMETER
--------------------------------------------------------------

ROOM_HEAT_DECREASE_RATE = 0.1
OVEN_HEAT_DECREASE_RATE = 0.05

--------------------------------------------------------------
-- MODEL
--------------------------------------------------------------
function ovenChange(t, ovenPast )
	if( t <= 60 )then
		return 0
	end
	return - OVEN_HEAT_DECREASE_RATE * ovenPast
end 

function roomChange( roomPast, ovenPast )
	return OVEN_HEAT_DECREASE_RATE * ovenPast - ROOM_HEAT_DECREASE_RATE * roomPast
end 

system = Agent{
	roomTemp  = 20,
	ovenTemp   = 300,
	execute		= function( self, t )
	
		local dOvenTemp =	ovenChange( t, self.ovenTemp )
		local dRoomTemp =	roomChange( self.roomTemp, self.ovenTemp )

		self.roomTemp = self.roomTemp + dRoomTemp
		self.ovenTemp = self.ovenTemp + dOvenTemp

	end
}

--------------------------------------------------------------
-- SIMULATION
--------------------------------------------------------------

obs1 = Observer{subject = system, type = "chart", attributes = {"roomTemp", "ovenTemp" } , title = "Temperature", curveLabels={"room","oven"}}


for t = 1, 70 do

	system:execute(t)

	print( t, system.roomTemp, system.ovenTemp )
	
	system:notify(t)

end