-- Lesson: Room & oven losing heat - Alternative 2.
-- Author: Tiago Carneiro

--------------------------------------------------------------
-- PARAMETER
--------------------------------------------------------------

ROOM_HEAT_DECREASE_RATE = 0.1
OVEN_HEAT_DECREASE_RATE = 0.05

--------------------------------------------------------------
-- MODEL
--------------------------------------------------------------
function ovenChange( t, ovenPast )
	if( t <= 60 )then
		return 0
	end
	return - OVEN_HEAT_DECREASE_RATE * ovenPast
end 

function roomChange( roomPast, ovenPast )
	return OVEN_HEAT_DECREASE_RATE * ovenPast - ROOM_HEAT_DECREASE_RATE * roomPast
end 

oven = Agent{
	temp  		= 300,
	execute		= function( self, change )
		self.temp = self.temp + change;
	end
}

room = Agent{
	temp  		= 20,
	execute		= function( self, change )
		self.temp = self.temp + change;
	end
}

--------------------------------------------------------------
-- SIMULATION
--------------------------------------------------------------

obs1 = Observer{subject = room, type = "chart", attributes = {"temp"} , title = "room"}
obs2 = Observer{subject = oven, type = "chart", attributes = {"temp"},  title = "oven" }

for t = 1, 70 do

	local dOvenTemp =   ovenChange( t, oven.temp )
	local dRoomTemp =	roomChange( room.temp, oven.temp )
	oven:execute(dOvenTemp)
	room:execute(dRoomTemp);
	print( t, room.temp, oven.temp )
	
	room:notify(t)
	oven:notify(t)
end