-- Lesson: Single room EXCHANGING heat with external environment.
-- Author: Tiago Carneiro

--------------------------------------------------------------
-- PARAMETER
--------------------------------------------------------------

HEAT_EXCHANGE_RATE 	= 0.1
EXTERNAL_TEMPERATURE 	= 5
FINAL_TIME 					= 60
--------------------------------------------------------------
-- MODEL
--------------------------------------------------------------
function change(tempPast )
	return  - HEAT_EXCHANGE_RATE * (tempPast - EXTERNAL_TEMPERATURE)
end 


system = Agent{
	temp  = 20,
	execute		= function( self )
		self.temp = self.temp + change( self.temp )
	end
}

--------------------------------------------------------------
-- SIMULATION
--------------------------------------------------------------

obs1 = Observer{subject = system, type = "chart", attributes = {"temp" } , title = "Temperature", curveLabels={"temp"}}


for t = 1, FINAL_TIME do

	system:execute( )

	print( t, system.temp )
	
	system:notify(t)

end