-- Lesson: Room with heating system.
-- Author: Tiago Carneiro

--------------------------------------------------------------
-- PARAMETER
--------------------------------------------------------------
THEMORSTAT_VALUE			= 30			-- 5 	25	(30)	50	100	1000	
HEAT_EXCHANGE_RATE 		= 0.1			-- (0.1)
FURNANCE_TEMPERATURE 	= 100		--	30	(100)
FINAL_TIME 						= 60 			-- 5	(60)
DT 									= 0.03125 	-- try	1		0.5		0.25 		0.125 		0.0625		(0.03125)
--------------------------------------------------------------
-- MODEL
--------------------------------------------------------------
function change(tempPast )
	local discrepancy = THEMORSTAT_VALUE - tempPast
	local heatingRate =  discrepancy / THEMORSTAT_VALUE
	return  FURNANCE_TEMPERATURE * heatingRate -  HEAT_EXCHANGE_RATE * tempPast
end 


system = Agent{
	temp  = 20,
	execute		= function( self )
		self.temp = self.temp + change( self.temp ) * DT
	end
}

--------------------------------------------------------------
-- SIMULATION
--------------------------------------------------------------

obs1 = Observer{subject = system, type = "chart", attributes = {"temp" } , title = "Temperature", curveLabels={"temp"}}


for t = 0, FINAL_TIME, DT do

	print( t, system.temp )

	system:execute( )

	system:notify(t)

end