-- Lesson: Room with heating system + Realistic loss to external environment.
-- Author: Tiago Carneiro

--------------------------------------------------------------
-- PARAMETER
--------------------------------------------------------------
EXTERNAL_TEMPERATURE		= 17			--	0 	(17)	42
THEMORSTAT_VALUE			= 30			-- 5 	25	(30)	50	100	1000	
HEAT_EXCHANGE_RATE 		= 0.1			-- 0	(0.1)	0.5	1
FURNANCE_TEMPERATURE 	= 30			--	(30)	100
FINAL_TIME 						= 60 			-- 5	(60)
DT 									= 0.03125 	-- try	1		0.5		0.25 		0.125 		0.0625		(0.03125)
--------------------------------------------------------------
-- MODEL
--------------------------------------------------------------
function change(tempPast )
	local thermostatDiscrepancy 		= THEMORSTAT_VALUE - tempPast
	local heatingRate 					=  thermostatDiscrepancy / THEMORSTAT_VALUE
	local environmentDiscrepancy	= tempPast - EXTERNAL_TEMPERATURE
	return  FURNANCE_TEMPERATURE * heatingRate -  HEAT_EXCHANGE_RATE * environmentDiscrepancy
end 


system = Agent{
	temp  = 20,
	execute		= function( self )
		self.temp = self.temp + change( self.temp ) * DT
	end
}

--------------------------------------------------------------
-- SIMULATION
--------------------------------------------------------------

obs1 = Observer{subject = system, type = "chart", attributes = {"temp" } , title = "Temperature", curveLabels={"temp"}}


for t = 0, FINAL_TIME, DT do

	print( t, system.temp )

	system:execute( )

	system:notify(t)

end